#!/usr/bin/python
# -*- coding: UTF-8 -*-
# _*_ coding: iso-8859-15 _*_

############################################################################
#                                                                          #
#  Utilitaire de configuration des messages pour bacula                    #
#  génère le fichier /etc/bacula/eolemsgdefs.pic                           #
#                                                                          #
#  licence GPL Eole                                                        #
#                                                                          #
#  Klaas TJEBBES klaas.tjebbes@ac-dijon.fr                                 # 
#                                                                          #
############################################################################

import os
import sys
import getopt
import pickle
from creole import parsedico

def chargedico():
    """charge le dictionnaire contenant les informations :
        serveur smtp
        adresse mail
        dico = {'smtp': serveur_smtp , 'mail': adresse_mail}
    """
    try:
        dico = pickle.load(file('/etc/bacula/eolemsgdefs.pic','r'))
    except:
        dico = {}
    return dico
					    
def savedico(dico):
    """enregistre le dictionnaire après modification
    """
    pickle.dump(dico,file('/etc/bacula/eolemsgdefs.pic','w'))
    return 0

def affiche(dico):
    """affiche serveur_smtp;adresse_mail
    rien si vide
    """
    try:
        if dico['smtp'] != "":
            print dico['smtp']+";"+dico['mail']
        else:
            print ""
    except:
        print ""
    sys.exit()

def delmail(dico):
    """supprime les données du dictionnaire et vide le fichier /etc/bacula/eolemessages.conf
    """
    dico['smtp'] = ""
    dico['mail'] = ""
    savedico(dico)
    sys.exit()

def main():
    # gestion des options
    servsmtp = None
    mail = None
    try:
        options, args = getopt.getopt(sys.argv[1:],'s:m:dl',
        ['servsmtp=',
        'mail=',
        'delete',
        'liste'])

    except getopt.GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % er_msg[er_msg.index('-')+1])

    for (opt,val) in options:
        # par quel SMTP envoyer les mails
        if (opt == '-s') or (opt == '--servsmtp'):
            servsmtp = val
        # à quelle adresse svp ?
        if (opt == '-m') or (opt == '--mail'):
            mail = val
        if (opt == '-d') or (opt == '--delete'):
            dico = chargedico()
            delmail(dico)
        #listing
        if (opt == '-l') or (opt == '--liste'):
            dico = chargedico()
            affiche(dico)

    # renseigne le fichier /etc/bacula/eolemessages.conf
    if servsmtp and mail:
        dico = chargedico()
        dico['smtp'] = servsmtp
        dico['mail'] = mail
        savedico(dico)
        return 0
    else:
        sys.exit("""
        options possibles :
            -s (--servsmtp)
            -m (--mail)
            -d (--delete)
            -l (--liste)
            """)

if __name__ == "__main__":
    main()

