#!/bin/bash

# Ces variables doivent être identiques à celles
# dans la section "__init__(self)" de
# /etc/bacula/scripts/DirStartUp.py
REPERTOIRE='/var/sauvegardes'
VERSION=`cat /etc/eole/version`
TEMOIN='/var/www/ead/tmp/temoin-bacula'
if [ "$VERSION" == scribe-1.0 ] || [ "$VERSION" == scribe-2.0 ]
then
    FICH_CONF='/var/www/ead/config/bacula-distant.txt'
    FICH_CONF_USB='/var/www/ead/config/bacula-usb.txt'
elif [ "$VERSION" == horus-1.0 ] || [ "$VERSION" == horus-2.0 ]
then
    FICH_CONF='/var/www/ead/tmp/bacula-distant.txt'
    FICH_CONF_USB='/var/www/ead/tmp/bacula-usb.txt'
fi

# Appel Bibliothèque
#[ -x /usr/share/eole/FonctionsEole ] || {
#  echo "Pas de bibliotheque Eole !"
#  exit 1
#}
#. /usr/share/eole/FonctionsEole

. ParseDico


servicestop(){
    [ -e /etc/init.d/samba ] &&  /etc/init.d/samba stop
    [ -e /etc/init.d/slapd ] &&  /etc/init.d/slapd stop
    [ -e /etc/init.d/mysql ] &&  /etc/init.d/mysql stop
    [ -e /etc/init.d/sympa ] &&  /etc/init.d/sympa stop
}

servicestart(){
    [ -e /etc/init.d/samba ] &&  /etc/init.d/samba start
    [ -e /etc/init.d/slapd ] &&  /etc/init.d/slapd start
    [ -e /etc/init.d/mysql ] &&  /etc/init.d/mysql start
    [ -e /etc/init.d/sympa ] &&  /etc/init.d/sympa start
}

demontage(){
    #monté plusieurs fois ...
    cpt=`mount |grep $REPERTOIRE -c`
    if [ "$cpt" != 0 ]
    then
	for i in `seq $cpt`
	do
	    /bin/umount $REPERTOIRE > /dev/null 2>&1
        done
    fi
}

distant(){
    demontage
    if [ -e ${FICH_CONF} ]
    then
        Param=(` /bin/cat ${FICH_CONF}`)
	pc_distant=${Param[0]}
	ip_pc_distant=${Param[1]}
	user=${Param[2]}
	pass=${Param[3]}
    fi
    if [  -n  "$pc_distant"  ]
    then
	if [ -n "$pass" ]
	then
            /bin/mount -t smbfs -o username=$user,password=$pass,ip=$ip_pc_distant $pc_distant $REPERTOIRE  > /dev/null 2>&1
	    if [ $? -ne 0 ]
	    then
		echo
		echo "######################################################"
		echo "# Erreur : Montage $pc_distant, $user Impossible 1"
		echo "######################################################"
		echo
		exit 1
            else
                echo "# Montage $pc_distant, $user OK #"
	    fi
        else
	    /bin/mount -t smbfs -o password="",ip=$ip_pc_distant $pc_distant $REPERTOIRE  > /dev/null 2>&1
	    if [ $? -ne 0 ]
	    then
		echo
		echo "######################################################"
		echo "# Erreur : Montage $pc_distant Impossible 2"
		echo "######################################################"
		echo
		exit 1
            else
                echo "# Montage $pc_distant (PC DISTANT) OK #"
	    fi
        fi
    else
        echo
        echo "######################################################"
	echo "# Vous devez renseigner vos paramètres de PC distant"
        echo "######################################################"
        echo
	exit 1
    fi
}

usb(){
    if [ -e ${FICH_CONF_USB} ]
    then
        usb_device=`cat ${FICH_CONF_USB}|head -n1|awk '{print $1}'`
    fi
    if [  -n  "$usb_device"  ]
    then
	demontage
        /bin/mount $usb_device $REPERTOIRE  > /dev/null 2>&1
        if [ $? -ne 0 ]
        then
            echo
            echo "######################################################"
            echo "Erreur : Montage $usb_device Impossible (USB)"
            echo "######################################################"
            echo
            exit 1
        else
	    echo "# Montage $usb_device (USB) OK #"
        fi
    else
        echo
        echo "######################################################"
        echo "#    Vous devez renseigner votre type du support     #"
        echo "######################################################"
        echo
        exit 1
    fi
}

prebackup(){
    touch $TEMOIN

    #Sauvegarde du SID
    if [ $VERSION == horus-2.0 ]
    then
        net getlocalsid | awk -F: '{print $2}' | awk -F " " '{print $1}'>/etc/eole/HORUS_SID
    elif [ $VERSION == scribe-2.0 ]
    then
        net getlocalsid | awk -F: '{print $2}' | awk -F " " '{print $1}'>/etc/eole/SCRIBE_SID
    fi    
}

postbackup(){
    /bin/rm $TEMOIN -f
    /etc/bacula/scripts/make_catalog_backup bacula bacula
    /bin/cp /var/lib/bacula/bacula.sql $REPERTOIRE/$VERSION-bacula.sql -f
    /bin/cp /etc/eole/config.eol $REPERTOIRE/$VERSION-config.eol -f
    /etc/bacula/scripts/delete_catalog_backup
    if [ "$VERSION" == scribe-1.0 ] || [ "$VERSION" == scribe-2.0 ]
    then
	/bin/cp /var/lib/bacula/ScribeBootStrap.bsr $REPERTOIRE -f
    elif [ "$VERSION" == horus-1.0 ] || [ "$VERSION" == horus-2.0 ]
    then
	/bin/cp /var/lib/bacula/EoleBootStrap.bsr $REPERTOIRE -f
    fi
    exit 0
}

postrestore(){
    if [ "$VERSION" == scribe-1.0 ] || [ "$VERSION" == scribe-2.0 ]
    then
        /bin/cat /etc/eole/SCRIBE_SID | xargs net setlocalsid
	#les uidNumbers changent d'une version à l'autre
	chown sympa:sympa /etc/mail/sympa_aliases
	chown openldap:openldap /var/lib/ldap/ -R
	chown mysql:mysql /var/lib/mysql/ -R
    elif [ "$VERSION" == horus-2.0 ]
    then
        /bin/cat /etc/eole/HORUS_SID | xargs net setlocalsid
	#les uidNumbers changent d'une version à l'autre
	chown openldap:openldap /var/lib/ldap/ -R
    fi
    exit 0
}

case $1 in
  prebackup)
      prebackup
      ;;
  postbackup)
      postbackup
      ;;
  postrestore)
      postrestore
      ;;
  usb)
      usb
      ;;
  distant)
      distant
      ;;
  servicestart)
      servicestart
      ;;
  servicestop)
      servicestop
      ;;
*)
      echo "Usage : "$0" prebackup|postbackup|postrestore|usb|distant|servicestart|servicestop"
      exit 1
esac

