#!/bin/bash
REPERTOIRE='/var/sauvegardes'
VERSION=`cat /etc/eole/version`

#monté plusieurs fois ...
cpt=`mount |grep $REPERTOIRE -c`
if [ "$cpt" != 0 ]
then
    for i in $cpt
    do
        /bin/umount $REPERTOIRE > /dev/null 2>&1
    done
fi

resto_dist(){
    echo "Nom NETBIOS de la station de sauvegarde Bacula"
    read pc_distant
    echo "Adresse IP de la station de sauvegarde Bacula"
    read ip_pc_distant
    echo "Nom du partage"
    read partage
    echo "Nom de l'utilisateur sinon rien"
    read user
    echo "Mot de passe sinon rien"
    read pass
    umount $REPERTOIRE
    if [ -n pass ]
    then
    	mount -t smbfs -o username=$user,password=$pass,ip=$ip_pc_distant //$pc_distant/$partage $REPERTOIRE
    	if [ $? -ne 0 ]
    	then
    		echo "Erreur : Montage $pc_distant Impossible"
    		exit 1
    	fi
     
    else
    	mount -t smbfs -o username="",password="",ip=$ip_pc_distant //$pc_distant/$partage $REPERTOIRE
    	if [ $? -ne 0 ]
    	then
    		echo "Erreur : Montage $pc_distant Impossible"
    		exit 1
    	fi
    fi
}

resto_usb(){
    echo "Quel est le chemin d'accès au périphérique (ex. : /dev/usb) ?"
    read periph_usb
    mount $periph_usb $REPERTOIRE
    if [ $? -ne 0 ]
    then
	echo "Erreur : Montage $periph_usb Impossible (USB)"
        exit 1
    fi
}

echo "Type de support ("distant" ou "usb"):"
read type_support
if [ "$type_support" == "distant" ]
then
    resto_dist
elif [ "$type_support" == "usb" ]
then
    resto_usb
else
    echo "Mauvais type de support \"$type_support\""
    exit 1
fi

rm -f /var/lib/bacula/bacula.db
/usr/bin/sqlite3 /var/lib/bacula/bacula.db < $REPERTOIRE/$VERSION-bacula.sql
service bacula-director restart
sleep 1
echo -e "restore all\n5\ndone\nyes\n"|bconsole -c /etc/bacula/bconsole.conf
echo "######################################################"
echo "Patientez ...."
echo ""
touch /var/log/bacula/bacula.log
tail -f /var/log/bacula/bacula.log -n0
